/*
======================================================
rslib component: misc functions implimentors
======================================================
*/

namespace rslib
{




	string HexDump(string str,bool slashrs)
	{
		stringstream ss;
		int strsize=str.size();

		const int cols=26;

		int pos=0;

		ss<<flush<<endl;

		while(pos<strsize)
		{
			for(int i=pos;i<pos+cols;i++)
			{
				if(i>=strsize)break;
				ss<<flush<< setw(2) << setfill ( '0' )<<uppercase<< hex <<(unsigned int)(unsigned char)str[i]<<" ";
			}
			if(slashrs)ss<<"\r";
			ss<<"\n";						
			
			for(int i=pos;i<pos+cols;i++)
			{
				if(i>=strsize)break;
				
				if((int)str[i] < 32 || 126 < (int)str[i])ss<<".  ";
				else ss<< str[i]<<"  ";	
			}
		
			pos+=cols;
			
			if(pos<strsize)
			{
				if(slashrs)ss<<"\r\n\r\n";
				else ss<<"\n\n";	
			}
		}
		
		ss<<dec;
		
		return ss.str();
	}	

	

	int stdsystem(string cmd,bool blockstderr,bool blockstdout)
	{			
		return system((cmd + (blockstdout && blockstderr ? " &>/dev/null" : (blockstdout ? " 1>/dev/null" : blockstderr ? " 2>/dev/null" : ""))).c_str());
	}
		


	ReturnStatus::ReturnStatus(bool success,string msg)
	{
		m_msg=msg;
		m_success=success;	
	}
	
	ReturnStatus::ReturnStatus()
	{
		m_msg="";
		m_success=true;	
	}	
	
	string ReturnStatus::GetMsg()
	{
		return m_msg;
	}
	
	bool ReturnStatus::Error()
	{	
		return !m_success;
	}
	
	/*ReturnStatus::operator bool() const
	{
		return m_success;
	}*/	

	

			
}


