/*
======================================================
rslib component: misc functions prototypes
======================================================
*/

#ifndef misc_h
#define misc_h

namespace rslib
{

	string HexDump(string str,bool slashrs=false);  //dump content of string into easy to read HEX format and return as string
	int stdsystem(string cmd,bool blockstderr=false,bool blockstdout=true);  //runs system() but takes a string

	
	
	
	//This class used when a function needs to return that something was an error, but also needs to return extra details.
	//this makes it easier to do so.
	class ReturnStatus
	{
		private:
			string m_msg;
			bool m_success;
			
		public:
			ReturnStatus(bool success,string msg);
			ReturnStatus();
			string GetMsg(); //get the return message
			bool Error();	 //return true if it's an error
			//operator bool() const;
	};


	
}


#endif


