/*
======================================================
rslib component: smart pointers implimentors
======================================================
*/


namespace rslib
{
	//basic count based smart pointer - still needs more testing!
	
	template <typename T>
	class SP
	{
			
		private:
		
			struct SPobject
			{				
					unsigned int refcount;	 //reference counts
					T * object;				 //actual object pointer
			};
			
			SPobject * DATA; //counter and actual data is stored here			
			
			bool CheckCount(bool); //set to true to increment, false to decrement, returns false if pointer should be deleted
			
			static bool DebugAlloc; //debug allocations
	
		public:
			SP(T * type);
			~SP();
			
			//overloads:
			SP<T>& operator=(const SP<T>&);
			SP(const SP<T> & sc); 
			bool operator==(const SP<T> & comp); 
			
			
			//accessors:
			T * Access(); //returns the original pointer so we can perform stuff with it
			
	
	};










}