/**********************************************************
EnviroState C++ header file
Environmental Monitoring System
Last modified by Red Squirrel on Oct-08-2012 01:51:46am
Filepath: includes/DataEntry.h
Lines of code: 14

Description: A simple data type to store a data entry point for a monitor

***********************************************************/


#ifndef dataentry_h
#define dataentry_h

class DataEntry
{
	friend class Monitor;
	friend class AgentCore;
	
	private:
		int value;		
		int date;		
		
	public:
		DataEntry();
		DataEntry(int value,int date);			
};

#endif