/*
======================================================
rslib component:  ConfigFile prototypes/implimentors
======================================================
*/

#ifndef configfile_h
#define configfile_h



namespace rslib
{
	struct SettingEntry
	{
		string field;
		string value;
	};


	class ConfigFile
	{
		private:
		SettingEntry * settings;
		int size;
		string filename;

		char unitseperator;
		char recordseperator;


		public:
		ConfigFile(string file,int size);
		~ConfigFile();
		void SetSeperator(char unit,char entry);
		bool Load();
		bool Save();
		string GetSetting(string name);
		string GetFileName();
		bool SetSetting(string name,string value);
		bool SetValue(string name,string value);
		bool DeleteSetting(string name);
		void GrowArray();
		void ListSettings();
	};

}


#endif

