/*
======================================================
rslib component:  prototypes/implimentors
======================================================
*/

/**
Notes: To use these ensure to add #define rslib_pthread before including rslib.h

Also compile with -pthread argument when using G++.

When using win32, the pthread libraries must be included, and the 2 DLLs must be included with the exe

*/





#ifndef pthread_h
#define pthread_h

namespace rslib
{

	//note: the windows implimentation of this may look clean but it is very dirty - its not guaranteed to work at all. Linux FTW
	class MUTEX
	{
		private:
			#ifdef WIN32
			bool mutex;
			#elif linux
			pthread_mutex_t mutex;
			#endif
			
		public:
			MUTEX();
			~MUTEX();
			void Lock(int delaybetweenlocks=0);
			bool TryLock();
			void UnLock();
	};




}


#endif


