/**********************************************************
EnviroState C++ source file
Environmental Monitoring System
Last modified by Red Squirrel on Sep-16-2012 12:18:47am
Filepath: includes/EmailClient.cpp
Lines of code: 46

Description: 

***********************************************************/


EmailClient::EmailClient()
{
	m_smtpserver="localhost";
	m_from="root@localhost.localdomain";
	m_client=NULL;
}


EmailClient::EmailClient(string smtpserver)
{
	m_smtpserver=smtpserver;
	m_from="root@localhost.localdomain";
	m_client=NULL;
}


EmailClient::~EmailClient()
{
	if(m_client!=NULL)delete m_client;
}

void EmailClient::SetFrom(string from)
{
	m_from=from;
}


bool EmailClient::SendTo(string to,string subject,string body)
{	
	body+="\n\nSent by EnviroState " + string(VERSION) + "\n";

	
	m_client = new SocketClient(m_smtpserver,25);
	bool ret=true;
	
	if(!m_client->Connect())
	{
		ret=false;	
	}
	else
	{
		m_client->SendString("helo localhost\r\n");
		//(ignore reply)
		m_client->SendString("mail from: " + m_from + " \r\n");
		//(ignore reply)
		m_client->SendString("rcpt to: " + to + " \r\n");
		//(ignore reply)
		m_client->SendString("data\r\n");
		//data:
		m_client->SendString("subject: " + subject + "\r\n");
		m_client->SendString("from: " + m_from + "\r\n");
		m_client->SendString("to: " + to + "\r\n");
		
		m_client->SendString("\r\n");
		
		m_client->SendString(body + "\r\n.\r\nquit");

		m_client->Disconnect();
	}

	delete m_client;
	m_client=NULL;
	
	
	return ret;

}