/**********************************************************
EnviroState C++ header file
Environmental Monitoring System
Last modified by Red Squirrel on Aug-14-2012 10:40:51pm
Filepath: includes/MlConfFile/MlConfVar.h
Lines of code: 24

Description: 

***********************************************************/


#ifndef MlConfVar_h
#define MlConfVar_h


class MlConfVar
{
  private:
    string m_name;
	
	short m_type;
    
    string * m_ValStr;
    int * m_ValInt;
    float * m_ValFlo;    
    
    
    void Init();
  
  public:
     MlConfVar(string name, string value);
     MlConfVar(string name, int value);
     MlConfVar(string name, float value);

     ~MlConfVar();
     string Name();
     
     
     string GetStr();
     int GetInt();
     float GetFlo();
     
     
     int Type();
     string TypeStr();
  
  
};


#endif